##############################################################################
#
# Copyright (c) 2001 Zope Corporation and Contributors. All Rights Reserved.
# 
# This software is subject to the provisions of the Zope Public License,
# Version 2.0 (ZPL).  A copy of the ZPL should accompany this distribution.
# THIS SOFTWARE IS PROVIDED "AS IS" AND ANY AND ALL EXPRESS OR IMPLIED
# WARRANTIES ARE DISCLAIMED, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED
# WARRANTIES OF TITLE, MERCHANTABILITY, AGAINST INFRINGEMENT, AND FITNESS
# FOR A PARTICULAR PURPOSE
# 
##############################################################################

import threading, traceback, time, socket
from websiteloadtest.common import Globals


class ClientHeartbeat(threading.Thread):
    """ thread to check server presence """

    running = 1

    def __init__(self,rp_server,cookie):

        threading.Thread.__init__(self)
        self.setName("clientheartbeat")

        self.interval  = Globals.CONFIG.getint('heartbeat','rate')
        self.rp_server = rp_server
        self.cookie    = cookie


    def run(self):

        while self.running:

            try:
                res = self.rp_server.REGISTRY.heartbeat(Globals.CLIENT_ALIAS)

                if res['msg'].find('re-register')>-1:

                    Globals.LOG.log_info('server requested to re-register', p=1)
                    self.rp_server.REGISTRY.register_client(Globals.CLIENT_HOST,Globals.CLIENT_PORT,self.cookie,Globals.CLIENT_ALIAS)
            
            except:
                Globals.LOG.log_error("heartbeat request to server failed", p=1)

            i = 0
            while self.running and i<self.interval:
                time.sleep(1)
                i+=1


    def stop(self):
        self.running = 0
