##############################################################################
#
# Copyright (c) 2001 Zope Corporation and Contributors. All Rights Reserved.
# 
# This software is subject to the provisions of the Zope Public License,
# Version 2.0 (ZPL).  A copy of the ZPL should accompany this distribution.
# THIS SOFTWARE IS PROVIDED "AS IS" AND ANY AND ALL EXPRESS OR IMPLIED
# WARRANTIES ARE DISCLAIMED, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED
# WARRANTIES OF TITLE, MERCHANTABILITY, AGAINST INFRINGEMENT, AND FITNESS
# FOR A PARTICULAR PURPOSE
# 
##############################################################################

import socket,time
from websiteloadtest.common import Globals

class Logger:
    """ UDP based logger """

    def __init__(self, host, port):
        self.host = host
        self.port = port 


    def udp_log(self,txt,severity):

        s = socket.socket(socket.AF_INET,socket.SOCK_DGRAM)

        # This is very strange ! Sending a datagram to self.host
        # raises an exception "host not found" although the host
        # is available both through DNS and /etc/hosts. And, it
        # works when using the interactive Python shell

        s.sendto(severity+':'+txt, (self.host,self.port))
#        s.sendto(severity+':'+txt, ('',self.port))
        s.close()

 
    def log(self,*args,**kw):

        severity = kw.get('severity','info')

        txt = ' '.join([ str(x) for x in args])
        txt = "%s: %s" % (Globals.CLIENT_HOST,txt)

        if kw.get('p',0)==1: print txt
        
        self.udp_log(txt, severity)


    def log_info(self,*args,**kw):    
        kw.update({'severity':'info'})
        apply(self.log,args,kw)

    def log_error(self,*args,**kw):  
        kw.update({'severity':'error'})
        apply(self.log,args,kw)
     
    def log_warn(self,*args,**kw):    
        kw.update({'severity':'warn'})
        apply(self.log,args,kw)
     
    def log_debug(self,*args,**kw):   
        kw.update({'severity':'debug'})
        apply(self.log,args,kw)
