##############################################################################
#
# Copyright (c) 2001 Zope Corporation and Contributors. All Rights Reserved.
# 
# This software is subject to the provisions of the Zope Public License,
# Version 2.0 (ZPL).  A copy of the ZPL should accompany this distribution.
# THIS SOFTWARE IS PROVIDED "AS IS" AND ANY AND ALL EXPRESS OR IMPLIED
# WARRANTIES ARE DISCLAIMED, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED
# WARRANTIES OF TITLE, MERCHANTABILITY, AGAINST INFRINGEMENT, AND FITNESS
# FOR A PARTICULAR PURPOSE
# 
##############################################################################

""" XmlRPCServer is derived from threading.thread and 
    provides support for a XML-RPC server
"""

import threading, time, socket
from websiteloadtest.common import SocketServer
from websiteloadtest.xmlrpclib import xmlrpcserver, xmlrpclib

SocketServer.TCPServer.allow_reuse_address = 1

class xmlrpcHandler(xmlrpcserver.RequestHandler):
    """ base handler for all XML RPC servers """

    def call(self, method, args):

        try:
            s_method = getattr(self, method)
        except:
            raise AttributeError, \
                'Method not found: %s' % method

        return apply(s_method,args)


class XmlRPCServer(threading.Thread):
    """ base XMLRPC server """

    running = 1

    def __init__(self, port, handler,name='unknown'):

        threading.Thread.__init__(self)
        self.setName(name)

        self.port = port
        self.srv = SocketServer.ThreadingTCPServer( ('',port), handler)


    def run(self):

        while self.running:

            try: self.srv.handle_request()
            except: pass


    def stop(self):
        # HACK !!!!!

        self.running = 0
        time.sleep(0.2)

        s = socket.socket(socket.AF_INET,socket.SOCK_STREAM)
        s.connect( ('',self.port) )
        s.send('I must die, die,die!')
         


def test():

    srv = XmlRPCServer(port=23124,handler=xmlrpcHandler,name='test')
    srv.start()

    print "test server started"
    time.sleep(2)
    print 'requesting to die'
    srv.stop()
    srv.join()
    print 'done'


if __name__=='__main__':
    test()

