##############################################################################
#
# Copyright (c) 2001 Zope Corporation and Contributors. All Rights Reserved.
# 
# This software is subject to the provisions of the Zope Public License,
# Version 2.0 (ZPL).  A copy of the ZPL should accompany this distribution.
# THIS SOFTWARE IS PROVIDED "AS IS" AND ANY AND ALL EXPRESS OR IMPLIED
# WARRANTIES ARE DISCLAIMED, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED
# WARRANTIES OF TITLE, MERCHANTABILITY, AGAINST INFRINGEMENT, AND FITNESS
# FOR A PARTICULAR PURPOSE
# 
##############################################################################

import socket,time
from websiteloadtest.common import Globals
from websiteloadtest.server.UDPServerThread import UDPServerThread

allLogLevel = ['debug','info','warn','error','fatal']


class LogUDPServer(UDPServerThread):
    """ UDP based logging server"""

    logLevel = 'info'

    def __init__(self, port, outputfile='rp_server.log'):
        UDPServerThread.__init__(self,port) 

        self.fp = open(outputfile,'a')
        print 'LogUDPServer started on port: %s, writing logs to "%s"' % \
                 (port,outputfile)


    def setLogLevel(self,level):
        self.logLevel = level


    def run(self):

        while self.running:

            data,addr = self.getdata()
            self.log(data)

        self.fp.close()

        Globals.LOG.log_info("%s terminated" % self.getName())         

    def log(self,data):

        if data.find(':')==-1:
            print "illegal logging string"
            return

        level = data.split(':')[0]       
 
        if  not level in allLogLevel:
            print 'illegal logging level:', level
            return

        if allLogLevel.index(level) < allLogLevel.index(self.logLevel):
            return 

        self.fp.write('%s %s\n' % \
            (time.strftime("%H:%M:%S",time.localtime()),data))

        self.fp.flush()



#def udp_log(host,port,txt,severity):
#
#    s = socket.socket(socket.AF_INET,socket.SOCK_DGRAM)
#    print 'xx:',severity+':'+txt
#    s.sendto(severity+':'+txt, (host,port))

